#include "mpu9250.h"
#include "mpuiic.h"
#include "delay.h"
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK STM32F746
//MPU9250	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//:2015/12/30
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2014-2024
//All rights reserved									  
////////////////////////////////////////////////////////////////////////////////// 	

//ʼMPU9250
//ֵ:0,ɹ
//    ,
u8 MPU9250_Init(void)
{
    u8 res=0;
    IIC_Init();     //ʼIIC
    MPU_Write_Byte(MPU9250_ADDR,MPU_PWR_MGMT1_REG,0X80);//λMPU9250
    delay_ms(100);  //ʱ100ms
    MPU_Write_Byte(MPU9250_ADDR,MPU_PWR_MGMT1_REG,0X00);//MPU9250
    MPU_Set_Gyro_Fsr(3);					        	//Ǵ,2000dps
	  MPU_Set_Accel_Fsr(0);					       	 	//ٶȴ,2g
    MPU_Set_Rate(50);						       	 	//ò50Hz
    MPU_Write_Byte(MPU9250_ADDR,MPU_INT_EN_REG,0X00);   //رж
	  MPU_Write_Byte(MPU9250_ADDR,MPU_USER_CTRL_REG,0X00);//I2Cģʽر
	  MPU_Write_Byte(MPU9250_ADDR,MPU_FIFO_EN_REG,0X00);	//رFIFO
	  MPU_Write_Byte(MPU9250_ADDR,MPU_INTBP_CFG_REG,0X82);//INTŵ͵ƽЧbypassģʽֱӶȡ
    res=MPU_Read_Byte(MPU9250_ADDR,MPU_DEVICE_ID_REG);  //ȡMPU6500ID
    if(res==MPU6500_ID) //IDȷ
    {
        MPU_Write_Byte(MPU9250_ADDR,MPU_PWR_MGMT1_REG,0X01);  	//CLKSEL,PLL XΪο
        MPU_Write_Byte(MPU9250_ADDR,MPU_PWR_MGMT2_REG,0X00);  	//ٶǶ
		    MPU_Set_Rate(50);						       	//òΪ50Hz   
    }else return 1;
 
    res=MPU_Read_Byte(AK8963_ADDR,MAG_WIA);    			//ȡAK8963 ID   
    if(res==AK8963_ID)
    {
        MPU_Write_Byte(AK8963_ADDR,MAG_CNTL1,0X11);		//AK8963Ϊβģʽ
    }else return 1;

    return 0;
}

//MPU9250Ǵ̷Χ
//fsr:0,250dps;1,500dps;2,1000dps;3,2000dps
//ֵ:0,óɹ
//    ,ʧ 
u8 MPU_Set_Gyro_Fsr(u8 fsr)
{
	return MPU_Write_Byte(MPU9250_ADDR,MPU_GYRO_CFG_REG,fsr<<3);//̷Χ  
}
//MPU9250ٶȴ̷Χ
//fsr:0,2g;1,4g;2,8g;3,16g
//ֵ:0,óɹ
//    ,ʧ 
u8 MPU_Set_Accel_Fsr(u8 fsr)
{
	return MPU_Write_Byte(MPU9250_ADDR,MPU_ACCEL_CFG_REG,fsr<<3);//üٶȴ̷Χ  
}

//MPU9250ֵͨ˲
//lpf:ֵͨ˲Ƶ(Hz)
//ֵ:0,óɹ
//    ,ʧ 
u8 MPU_Set_LPF(u16 lpf)
{
	u8 data=0;
	if(lpf>=188)data=1;
	else if(lpf>=98)data=2;
	else if(lpf>=42)data=3;
	else if(lpf>=20)data=4;
	else if(lpf>=10)data=5;
	else data=6; 
	return MPU_Write_Byte(MPU9250_ADDR,MPU_CFG_REG,data);//ֵͨ˲  
}

//MPU9250Ĳ(ٶFs=1KHz)
//rate:4~1000(Hz)
//ֵ:0,óɹ
//    ,ʧ 
u8 MPU_Set_Rate(u16 rate)
{
	u8 data;
	if(rate>1000)rate=1000;
	if(rate<4)rate=4;
	data=1000/rate-1;
	data=MPU_Write_Byte(MPU9250_ADDR,MPU_SAMPLE_RATE_REG,data);	//ֵͨ˲
 	return MPU_Set_LPF(rate/2);	//ԶLPFΪʵһ
}

//õ¶ֵ
//ֵ:¶ֵ(100)
short MPU_Get_Temperature(void)
{
    u8 buf[2]; 
    short raw;
	float temp;
	MPU_Read_Len(MPU9250_ADDR,MPU_TEMP_OUTH_REG,2,buf); 
    raw=((u16)buf[0]<<8)|buf[1];  
    temp=21+((double)raw)/333.87;  
    return temp*100;;
}
//õֵ(ԭʼֵ)
//gx,gy,gz:x,y,zԭʼ()
//ֵ:0,ɹ
//    ,
u8 MPU_Get_Gyroscope(short *gx,short *gy,short *gz)
{
    u8 buf[6],res; 
	res=MPU_Read_Len(MPU9250_ADDR,MPU_GYRO_XOUTH_REG,6,buf);
	if(res==0)
	{
		*gx=((u16)buf[0]<<8)|buf[1];  
		*gy=((u16)buf[2]<<8)|buf[3];  
		*gz=((u16)buf[4]<<8)|buf[5];
	} 	
    return res;;
}
//õٶֵ(ԭʼֵ)
//gx,gy,gz:x,y,zԭʼ()
//ֵ:0,ɹ
//    ,
u8 MPU_Get_Accelerometer(short *ax,short *ay,short *az)
{
    u8 buf[6],res;  
	res=MPU_Read_Len(MPU9250_ADDR,MPU_ACCEL_XOUTH_REG,6,buf);
	if(res==0)
	{
		*ax=((u16)buf[0]<<8)|buf[1];  
		*ay=((u16)buf[2]<<8)|buf[3];  
		*az=((u16)buf[4]<<8)|buf[5];
	} 	
    return res;;
}

//õֵ(ԭʼֵ)
//mx,my,mz:x,y,zԭʼ()
//ֵ:0,ɹ
//    ,
u8 MPU_Get_Magnetometer(short *mx,short *my,short *mz)
{
    u8 buf[6],res;  
	res=MPU_Read_Len(AK8963_ADDR,MAG_XOUT_L,6,buf);
	if(res==0)
	{
		*mx=((u16)buf[1]<<8)|buf[0];  
		*my=((u16)buf[3]<<8)|buf[2];  
		*mz=((u16)buf[5]<<8)|buf[4];
	} 	
    MPU_Write_Byte(AK8963_ADDR,MAG_CNTL1,0X11); //AK8963ÿζԺҪΪβģʽ
    return res;;
}

//IICд
//addr:ַ 
//reg:Ĵַ
//len:д볤
//buf:
//ֵ:0,
//    ,
u8 MPU_Write_Len(u8 addr,u8 reg,u8 len,u8 *buf)
{
    u8 i;
    IIC_Start();
    IIC_Send_Byte((addr<<1)|0); //ַ+д
    if(IIC_Wait_Ack())          //ȴӦ
    {
        IIC_Stop();
        return 1;
    }
    IIC_Send_Byte(reg);         //дĴַ
    IIC_Wait_Ack();             //ȴӦ
    for(i=0;i<len;i++)
    {
        IIC_Send_Byte(buf[i]);  //
        if(IIC_Wait_Ack())      //ȴACK
        {
            IIC_Stop();
            return 1;
        }
    }
    IIC_Stop();
    return 0;
} 

//IIC
//addr:ַ
//reg:ҪȡļĴַ
//len:Ҫȡĳ
//buf:ȡݴ洢
//ֵ:0,
//    ,
u8 MPU_Read_Len(u8 addr,u8 reg,u8 len,u8 *buf)
{ 
    IIC_Start();
    IIC_Send_Byte((addr<<1)|0); //ַ+д
    if(IIC_Wait_Ack())          //ȴӦ
    {
        IIC_Stop();
        return 1;
    }
    IIC_Send_Byte(reg);         //дĴַ
    IIC_Wait_Ack();             //ȴӦ
	IIC_Start();                
    IIC_Send_Byte((addr<<1)|1); //ַ+
    IIC_Wait_Ack();             //ȴӦ
    while(len)
    {
        if(len==1)*buf=IIC_Read_Byte(0);//,nACK 
		else *buf=IIC_Read_Byte(1);		//,ACK  
		len--;
		buf++;  
    }
    IIC_Stop();                 //һֹͣ
    return 0;       
}

//IICдһֽ 
//devaddr:IICַ
//reg:Ĵַ
//data:
//ֵ:0,
//    ,
u8 MPU_Write_Byte(u8 addr,u8 reg,u8 data)
{
    IIC_Start();
    IIC_Send_Byte((addr<<1)|0); //ַ+д
    if(IIC_Wait_Ack())          //ȴӦ
    {
        IIC_Stop();
        return 1;
    }
    IIC_Send_Byte(reg);         //дĴַ
    IIC_Wait_Ack();             //ȴӦ
    IIC_Send_Byte(data);        //
    if(IIC_Wait_Ack())          //ȴACK
    {
        IIC_Stop();
        return 1;
    }
    IIC_Stop();
    return 0;
}

//IICһֽ 
//reg:Ĵַ 
//ֵ:
u8 MPU_Read_Byte(u8 addr,u8 reg)
{
    u8 res;
    IIC_Start();
    IIC_Send_Byte((addr<<1)|0); //ַ+д
    IIC_Wait_Ack();             //ȴӦ
    IIC_Send_Byte(reg);         //дĴַ
    IIC_Wait_Ack();             //ȴӦ
	  IIC_Start();                
    IIC_Send_Byte((addr<<1)|1); //ַ+
    IIC_Wait_Ack();             //ȴӦ
    res=IIC_Read_Byte(0);		//,nACK  
    IIC_Stop();                 //һֹͣ
    return res;  
}
